<template>
  <q-page padding>
    <div>
      <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
        Evento: : &nbsp;
        <span>
          {{ evento?.evento }}
        </span>
        <q-space />

        <div class="q-gutter-xs">
          <q-btn
            flat
            dense
            icon="arrow_back_ios_new"
            label="Atras"
            href="javascript:history.go(-1)"
          />
        </div>
      </q-toolbar>
      <div class="row">
        <div class="col-md col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section>Fecha : </q-item-section>
              <q-item-section side>
                {{ $filters.Date(evento?.evento_inicio) }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>
        <div class="col-md col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section>| Responsable: </q-item-section>
              <q-item-section side>
                {{ evento?.responsable }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>
        <div class="col-md col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section>| Area: </q-item-section>
              <q-item-section side>
                {{ evento?.area }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>
        <div class="col-md col-xs-12">
          <q-list dense padding>
            <q-item>
              <q-item-section>| Organismo: </q-item-section>
              <q-item-section side>
                {{ evento?.organismo }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>
      </div>
    </div>

    <q-banner rounded class="bg-blue text-white" v-if="evento?.cada">
      El evento es "Capacitación para adquirir los Derechos Asociativos" por
      esta razón solo aparecerán los mayores de 16 años al dia del encuentro
    </q-banner>

    <q-table
      title="Nomina"
      :dense="true"
      :rows="dataSet"
      :columns="columnas"
      row-key="uuid"
      hide-bottom
      :rows-per-page-options="[0]"
      :loading="loading"
    >
      <!--------------------------------------
            loading
          ---------------------------------------->
      <template v-slot:loading>
        <Loading showing />
      </template>

      <template v-slot:body-cell-datos="props">
        <q-td :props="props">
          <PersonaDetalle :persona="props.row.persona"></PersonaDetalle>
        </q-td>
      </template>

      <template v-slot:body-cell-funcion="props">
        <q-td :props="props">
          <PersonasFunciones :funciones="props.row.persona.funciones" />
        </q-td>
      </template>

      <template v-slot:body-cell-estado="props">
        <q-td :props="props">
          <template v-if="props.row.inscripto_uuid">
            <q-chip square dark size="sm" color="green" icon="thumb_up">
              Si Participa
            </q-chip>
          </template>
          <template v-else>
            <q-chip square dark size="sm" color="red" icon="thumb_down">
              No Participa
            </q-chip>
          </template>
        </q-td>
      </template>

      <template v-slot:body-cell-opciones="props">
        <q-td :props="props">
          <template
            v-if="
              moment(evento.cierre_inscripcion).format('YYYY-MM-DD') >=
              moment().format('YYYY-MM-DD')
            "
          >
            <template v-if="props.row.inscripto_uuid">
              <q-btn
                flat
                color="red"
                :loading="progress[props.row.inscripto_uuid]"
                @click="darDeBajaInscripto(props.row.inscripto_uuid)"
              >
                Dar de Baja
              </q-btn>
            </template>
            <template v-else>
              <q-btn
                flat
                color="green"
                :loading="progress[props.row.persona.uuid]"
                @click="darDeAltaInscripto(props.row.persona)"
              >
                Dar de Alta
              </q-btn>
            </template>
          </template>
          <template v-else>
            <div class="text-center small">
              Inscripcion Cerrada el
              <br />
              {{ $filters.Date(evento.cierre_inscripcion) }}
            </div>
          </template>
        </q-td>
      </template>
    </q-table>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, Ref } from 'vue';
import { QTableProps } from 'quasar';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonasFunciones from 'components/Personas/Funciones.vue';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRoute } from 'vue-router';
import moment from 'moment';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'funcion', label: 'Función', field: 'funcion', align: 'left' },
  { name: 'estado', label: 'Estado', field: 'estado', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: {
    Loading,
    PersonaDetalle,
    PersonasFunciones,
  },

  name: 'EventosPage',
  setup() {
    const dataSet = ref([]);
    const evento = ref(null);

    const loading = ref(true);
    const progress: Ref<boolean[]> = ref([]);
    const route = useRoute();
    const uuid = route.params.uuid;
    onMounted(() => {
      getEventos();
      getPersonas();
    });

    // function getEvento() {}

    function getPersonas(): Promise<boolean> {
      return api
        .get('/api/eventos/eventos/disponibles/' + uuid)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          return Promise.resolve(true);
        })
        .finally(() => {
          loading.value = false;
        });
    }
    function getEventos() {
      api
        .get('/api/eventos/eventos/' + uuid)
        .then((response: AxiosResponse) => {
          evento.value = response.data;
        });
    }

    function darDeAltaInscripto(persona: string) {
      progress.value[persona.uuid] = true;
      api
        .post('/api/eventos/inscriptos', {
          persona_uuid: persona.uuid,
          evento_uuid: evento.value.uuid,
        })
        .finally(() => {
          getPersonas().finally(() => {
            progress.value[persona.uuid] = false;
          });
        });
    }
    function darDeBajaInscripto(inscriptoUuid: string) {
      progress.value[inscriptoUuid] = true;
      api
        .delete('/api/eventos/inscriptos', {
          params: { inscripto_uuid: inscriptoUuid },
        })
        .finally(() => {
          getPersonas().finally(() => {
            progress.value[inscriptoUuid] = false;
          });
        });
    }

    return {
      loading,
      dataSet,
      columnas,
      evento,
      darDeBajaInscripto,
      darDeAltaInscripto,
      moment,
      progress,
    };
  },
});
</script>
